> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tensormesh.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Update GPU Pricing



## OpenAPI

````yaml /tensormesh-api/specs/billing/v1/pricing_service.openapi.json put /v1/admin/billing/gpu-pricing
openapi: 3.0.3
info:
  title: Tensormesh Control Plane API (billing/v1/pricing_service)
  version: 0.1.0
  description: >-
    Authentication: Authorization: Bearer <access_token> (obtain via tm auth
    login).
servers:
  - url: https://api.tensormesh.ai
security:
  - BearerAuth: []
tags:
  - name: PricingService
paths:
  /v1/admin/billing/gpu-pricing:
    put:
      tags:
        - PricingService
      summary: Update GPU Pricing
      operationId: PricingService_UpdateGpuPricing
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/v1UpdateGpuPricingRequest'
        required: true
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1UpdateGpuPricingResponse'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
components:
  schemas:
    v1UpdateGpuPricingRequest:
      type: object
      properties:
        pricing:
          $ref: '#/components/schemas/v1GpuPricing'
    v1UpdateGpuPricingResponse:
      type: object
      properties:
        pricing:
          $ref: '#/components/schemas/v1GpuPricing'
    rpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
          description: |-
            The status code, which should be an enum value of
            [google.rpc.Code][google.rpc.Code].
        message:
          type: string
          description: >-
            A developer-facing error message, which should be in English. Any

            user-facing error message should be localized and sent in the

            [google.rpc.Status.details][google.rpc.Status.details] field, or
            localized

            by the client.
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
          description: >-
            A list of messages that carry the error details.  There is a common
            set of

            message types for APIs to use.
      description: >-
        The `Status` type defines a logical error model that is suitable for

        different programming environments, including REST APIs and RPC APIs. It
        is

        used by [gRPC](https://github.com/grpc). Each `Status` message contains

        three pieces of data: error code, error message, and error details.


        You can find out more about this error model and how to work with it in
        the

        [API Design Guide](https://cloud.google.com/apis/design/errors).
    v1GpuPricing:
      type: object
      properties:
        gpuType:
          $ref: '#/components/schemas/v1GPUType'
        cloudProvider:
          $ref: '#/components/schemas/v1CloudProvider'
        hourlyRate:
          $ref: '#/components/schemas/typeMoney'
        isActive:
          type: boolean
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
    v1GPUType:
      type: string
      enum:
        - GPU_TYPE_UNSPECIFIED
        - GPU_TYPE_A100
        - GPU_TYPE_H100
        - GPU_TYPE_H200
        - GPU_TYPE_B200
      default: GPU_TYPE_UNSPECIFIED
      description: >-
        GPUType specifies the type of GPU to use for a model deployment.


        This enum defines the supported GPU types for model deployments. It
        allows

        clients to specify the exact GPU hardware they need for their models.


        enum definitions
    v1CloudProvider:
      type: string
      enum:
        - CLOUD_PROVIDER_UNSPECIFIED
        - CLOUD_PROVIDER_ONPREM
        - CLOUD_PROVIDER_NEBIUS
        - CLOUD_PROVIDER_LAMBDA
        - CLOUD_PROVIDER_YOTTA
      default: CLOUD_PROVIDER_UNSPECIFIED
      description: >-
        CloudProvider specifies which cloud infrastructure provider to use for
        deployment.


        Currently supported providers:
          - On-premise infrastructure (self-hosted)
          - Nebius (https://nebius.com) - European and US cloud GPU provider
          - Lambda Labs (https://lambdalabs.com) - US-based GPU cloud provider
          - Yotta provider
    typeMoney:
      type: object
      properties:
        currencyCode:
          type: string
          description: The three-letter currency code defined in ISO 4217.
        units:
          type: string
          format: int64
          description: >-
            The whole units of the amount.

            For example if `currencyCode` is `"USD"`, then 1 unit is one US
            dollar.
        nanos:
          type: integer
          format: int32
          description: >-
            Number of nano (10^-9) units of the amount.

            The value must be between -999,999,999 and +999,999,999 inclusive.

            If `units` is positive, `nanos` must be positive or zero.

            If `units` is zero, `nanos` can be positive, zero, or negative.

            If `units` is negative, `nanos` must be negative or zero.

            For example $-1.75 is represented as `units`=-1 and
            `nanos`=-750,000,000.
      description: Represents an amount of money with its currency type.
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        Bearer authentication using an access token. Format: Bearer
        <access_token>

````